900 TURBO_objfil 'ram1_MAKE_MODULES_BIN':TURBO_buffersz 200
910 TURBO_model '<':TURBO_diags 0:TURBO_windo 0
920 TURBO_taskn 'Make_Modules v2.01':TURBO_repfil 'ram1_err'
930 TURBO_struct 's':TURBO_optim 'b'
1000 DATA_AREA 20:IMPLICIT% rest,def_line,module
1005 IF COMPILED:OPEN#1,con
1010 line_max%=100:max_defs%=99
1020 DIM Ky$(1),in$(36),out$(36),defn$(max_defs%,line_max%)
1030 DIM def_modno%(max_defs%),defpos(max_defs%),line$(line_max%)
1040 PAPER 0:INK 7:WINDOW 512,256,0,0:CLS
1050 MODE 4:WINDOW 412,200,40,10:BORDER 2,2:BORDER 8,128
1060 BORDER 6,2:BORDER 4,7,2:BORDER 2,2:BORDER 8,128
1070 CSIZE 2,1:PRINT" TURBO MODULE MAKER, V 2.01":CSIZE 1,0
1080 PRINT\"Lines from 1 to <the total number of DEFs> must"
1090 PRINT"be free for GLOBAL and EXTERNAL declarations,"
1100 PRINT"which are created for you. If need be, you must"
1110 PRINT"add declarations for 'implicit' GLOBALs, i.e."
1120 PRINT"any shared variables NOT passed as parameters."
1130 PRINT\"READ & DATA should not be separated by DEFs, &"
1140 PRINT"value parameters are assumed - see UPDATE_DOC."
1150 QUESTION_USER:FIND_DEFS:CREATE_MODULES:Stip
1160 :
1170 DEFine PROCedure QUESTION_USER
1180  LOCal status,module
1190  in$="FLP1_"
1200  REPeat get_in
1210   PRINT\"Input file:":in$=EDIT$(in$,36)
1215   IF in$="":Cease 0
1220   IF DEVICE_STATUS(1,(in$))>0:EXIT get_in
1230   PRINT"++++ Unable to read ";in$
1240  END REPeat get_in
1250  OPEN_IN#3,in$
1260  REPeat get_count
1270   modules%=2
1280   PRINT\"Number of modules required:";
1290   modules%=EDIT%(modules%,2)
1300   IF modules%>1:EXIT get_count
1310   PRINT"++++ You must create at least 2 modules."
1320  END REPeat get_count
1330  DIM block_end(modules%)
1340  out$=in$
1350  REPeat get_out
1360   PRINT\"Output file name stem:"
1370   PRINT"{e.g. FLP1_BIGPROG for FLP1_BIGPROG1..";modules%;"}"
1380   out$=EDIT$(out$,33)
1385   IF out$="":Cease 1
1390   status=DEVICE_STATUS(-1,(out$ & "1" ))
1400   IF status>0:EXIT get_out
1410   IF status=-8
1420    PRINT"++++ Delete ";out$;"1..";modules%;
1430    IF YEA_OR_NAY
1440     FOR module=1 TO modules%:DELETE (out$) & module
1450     EXIT get_out
1460    END IF
1470   END IF
1480  END REPeat get_out
1490 END DEFine
1500 :
1510 DEFine PROCedure FIND_DEFS
1520  LOCal defpos%,endpos%,here
1530  CLS:PRINT\"Scanning the file ";in$;" ,"
1540  PRINT\"looking for suitable split-points."
1550  PRINT\"0  routine DEFs found."
1560  def_count%=0
1570  REPeat locate_def
1580   here=POSITION(#3)
1590   IF EOF(#3):EXIT locate_def
1600   INPUT#3,line$
1610   defpos%="DEFINE " INSTR (line$)
1620   IF defpos%=0:NEXT locate_def
1630   IF LEN(line$)<defpos%+16:NEXT locate_def
1640   endpos%="END" INSTR line$
1650   IF endpos%<>0 AND endpos%<defpos%:NEXT locate_def
1660   IF "'" INSTR line$ OR '"' INSTR line$:NEXT locate_def
1670   def_count%=def_count%+1
1680   IF def_count%>max_defs%
1690    PRINT\\"**** More than ";max_defs%;" DEFs in"!in$
1700    PRINT"Please increase MAX_DEFS% and re-compile."
1710    CLOSE#3:Stip
1720   END IF
1730   AT 5,0:PRINT def_count%;
1740   defn$(def_count%)="TURBO_"&line$(defpos%+7)&" "&line$(defpos%+16+(line$(defpos%+7)="P") TO LEN(line$))
1750   defpos(def_count%)=here
1760  END REPeat locate_def
1770  input_length=POSITION(#3)-1
1780  PRINT\\
1790 END DEFine
1800 :
1810 DEFine PROCedure CREATE_MODULES
1820  LOCal def_index%,here,module,rest,mod_float
1830  FIND_DECL_LENGTH
1840  block_end(modules%)=input_length
1850  SET_POSITION#3,0:def_index%=0
1860  INPUT#3,line$:firstnum="0" & line$
1870  IF firstnum<=def_count%
1880   PRINT"**** No room to insert declaration lines."
1890   PRINT"Please RENUM ";def_count%+1;" (or more) & try again."
1900   CLOSE#3:Stip
1910  END IF
1920  SET_POSITION#3,0
1930  IF def_count%<modules%
1940   PRINT"**** ";def_count%;" DEFs won't split into ";
1950   PRINT modules% & " modules.":CLOSE#3:Stip
1960  END IF
1970  FOR module=1 TO modules%-1
1980   REPeat find_chop_point
1990    mod_float=module
2000    IF defpos(def_index%)>input_length*(mod_float/modules%)
2010     EXIT find_chop_point
2020    ELSE
2030     def_index%=def_index%+1
2040     IF def_index%=def_count%:EXIT find_chop_point
2050     def_modno%(def_index%)=module
2060    END IF
2070   END REPeat find_chop_point
2080   def_modno%(def_index%)=module+1
2090   block_end(module)=defpos(def_index%)-1
2100  END FOR module
2110  FOR rest=def_index% TO def_count%
2120   def_modno%(rest)=modules%
2130  END FOR rest
2140  FOR module=1 TO modules%
2150   MAKE_MODULE module,block_end(module)
2160  END FOR module
2170  PRINT in$!"split into"!out$ & "1.." & modules%
2180  CLOSE#3
2190 END DEFine
2200 :
2210 DEFine PROCedure MAKE_MODULE(module_no%,end_pos)
2220  LOCal current_pos,buffer_size,modfile$(40)
2230  current_pos=POSITION(#3)
2240  modfile$=out$ & module_no%
2250  IF current_pos>=end_pos
2260   PRINT"++++ Module ";modfile$!"would be empty,"
2270   PRINT"so it has not been created.":RETurn
2280  END IF
2290  REPeat check_room
2300   IF DEVICE_STATUS((modfile$))<end_pos+decl_length-current_pos
2310    IF NOT(in$(1 TO 4)==out$(1 TO 4))
2320     PRINT"++++ Unable to create"!modfile$
2330     PRINT"Do you want it put on another medium";
2340     IF YEA_OR_NAY
2350      PRINT"Please swap media, then press a key."
2360      Ky$=INKEY$(#1,-1):NEXT check_room
2370     END IF
2380    END IF
2390    PRINT"**** Drive full - task aborted.":CLOSE#3:Stip
2400   ELSE
2410    EXIT check_room
2420   END IF
2430  END REPeat check_room
2440  PRINT"Creating module:"!modfile$
2450  OPEN_NEW#4,(modfile$)
2460  WRITE_DECLS
2470  buffer_size=FREE_MEMORY/2-150
2480  IF buffer_size>32760:buffer_size=32760
2490  REPeat write_block
2500   IF current_pos+buffer_size>end_pos
2510    PRINT#4,INPUT$(#3,end_pos-current_pos+1);:EXIT write_block
2520   ELSE
2530    PRINT#4,INPUT$(#3,buffer_size);
2540    current_pos=current_pos+buffer_size
2550   END IF
2560  END REPeat write_block
2570  CLOSE#4
2580 END DEFine
2590 :
2600 DEFine FuNction YEA_OR_NAY
2610  PRINT" (Y/N) ? ";:CURSOR_ON
2620  REPeat poll
2630   Ky$=INKEY$(#1,-1)
2640   IF Ky$=="y" OR Ky$=="n"
2650    PRINT Ky$:CURSOR_OFF:RETurn Ky$=="y"
2660   END IF
2670  END REPeat poll
2680 END DEFine
2690 :
2700 DEFine PROCedure WRITE_DECLS
2710  LOCal def_line,lineno%
2720  lineno%=1
2730  FOR def_line=1 TO def_count%
2740   IF module_no%=def_modno%(def_line)
2750    PRINT#4;lineno%;" GLOBAL ";def_modno%(def_line);",";
2760    PRINT#4,defn$(def_line):lineno%=lineno%+1
2770   END IF
2780  END FOR def_line
2790  FOR def_line=1 TO def_count%
2800   IF module_no%<>def_modno%(def_line)
2810    PRINT#4;lineno%;" EXTERNAL ";def_modno%(def_line);",";
2820    PRINT#4,defn$(def_line):lineno%=lineno%+1
2830   END IF
2840  END FOR def_line
2850  IF module_no%=1
2860   decl_length=decl_length+7
2870  ELSE
2880   SET_POSITION#4,POSITION(#4)-1:PRINT#4;":SNOOZE"
2890  END IF
2900 END DEFine
2910 :
2920 DEFine PROCedure FIND_DECL_LENGTH
2930  LOCal def_line,par_pos%
2940  decl_length=(12+LEN(def_count% & modules%))*def_count%
2950  FOR def_line=1 TO def_count%
2960   line$=defn$(def_line)
2970   par_pos%="(" INSTR line$
2980   IF par_pos%>0
2990    INSERT$ line$,"(",par_pos%,0
3000    par_pos%=")" INSTR line$:INSERT$ line$,")",par_pos%,0
3010    REPeat brackets
3020     par_pos%="," INSTR line$:IF par_pos%=0:EXIT brackets
3030     INSERT$ line$,") (",par_pos%,1
3040    END REPeat brackets
3050   END IF
3060   REPeat comma
3070    par_pos%=" " INSTR line$:IF par_pos%=0:EXIT comma
3080    line$(par_pos%)=","
3090   END REPeat comma
3100   defn$(def_line)=line$:decl_length=decl_length+LEN(line$)
3110  END FOR def_line
3120 END DEFine
3130 :
3140 REFERENCE s$
3150 DEFine PROCedure INSERT$(s$,c$,pos%,chop%)
3160  IF LEN(line$)=pos%:s$=s$ & c$:RETurn
3170  s$=s$(1 TO pos%-chop%) & c$ & s$(pos%+1 TO LEN(line$))
3180 END DEFine
3190 :
3200 DEFine PROCedure Stip
3210  OPEN#5,con
3220  Ky$=INKEY$(#5,400)
3225  STOP
3230 END DEFine
3240 :
3250 DEFine PROCedure Cease(o)
3260  IF o:CLOSE#3
3270  PRINT "++++ Quitting . . .":Stip
3280 END DEFine
