10 TURBO_objfil 'ram1_TASCOM3' : TURBO_taskn "TASCOM v2.4"
20 TURBO_objdat 10 : TURBO_buffersz 200
30 TURBO_repfil "ram1_err":TURBO_optim 'b'
40 TURBO_locstr 'r':TURBO_diags 1
50 TURBO_windo 0:TURBO_struct 's'
100 REMark Program to convert any Task into a Resident Procedure
110 REMark TURBO TOOLKIT version 2.4, with full parameter passing
120 REMark 6 SEP 01
130 maxcode=2^20 :REMark DIY fast load limits tasks to 1 Megabyte
140 :
150 OPEN#4,scr
160 IF COMPILED : OPEN #1,CON :REMark Avoid messing up screen
170 WINDOW#4, 400,150,36,30 : BORDER#4, 2,0,7 : PAPER#4, 0 : CLS#4
180 PAPER#4, 2 : INK#4, 7,4 : CSIZE#4, 2,1 : CLS#4, 3
190 PRINT#4, "TURBO COMMANDER - file converter"
200 PAPER#4, 7 : INK#4, 2 : CSIZE#4, 1,0 : CLS#4, 3
210 PRINT#4, "    Written by Phil Borman & Simon N Goodwin."
220 IF COMPILED:RESTORE 1360:READ char_s%,reent%:ELSE char_s%=1:reent%=0
230 INK#4, 0:PAPER#4, 4:AT#4, 3,0:CLS#4, 3
240 PRINT#4, " Reentrance -                 Default #1 -":INK#4, 2
250 Tell 43,char_s%:Tell 14,reent%
260 INK 4 : PAPER 0 : pass=0
270 WINDOW 376,100,48,75
280 REMark char_s%=0 for no default #1 added - reent% = 0 for no reentrance
290 DIM source$(42),destin$(42),name$(42),k$(2)
300 :
310 REPeat maker
320   PRINT : pass=pass+1
330   IF OPTION_CMD$="" OR pass>1
340     INPUT 'Source file >'!source$
350   ELSE
360     source$=OPTION_CMD$
370     PRINT 'Source file ='!source$
380   END IF
390   IF source$="" : EXIT maker
400   fault=DEVICE_STATUS(1,source$)
410   IF fault<0 : PRINT 'Error'!fault!'reading'!source$ : NEXT maker
420   OPEN_IN #3,source$
430   SET_POSITION #3,maxcode+1
440   file_length=POSITION(#3)
450   CLOSE #3
460   IF file_length>maxcode OR 2*INT(file_length/2)<>file_length
470     PRINT source$!"has odd or excessive size" : NEXT maker
480   END IF
490   file_data=DATASPACE(source$)+13
500   IF file_data<16 : PRINT source$;" data space too small" : NEXT maker
510   INPUT 'Destination >'!destin$
520   INPUT 'Keyword     >'!name$\\
530   NL%=LEN(name$)
540   IF NL%=0 : PRINT "Huh?" : EXIT maker
550   top=file_length+400+NL%
560   buffer=ALLOCATION(top)
570   IF buffer<0 : PRINT "Fatal error - insufficient free RAM" : EXIT maker
580   top=buffer+top
590   b=buffer : RESTORE 1160 : DATASTORE 1110 : REMark Store BP.INIT code
600   wh=char_s%+2*reent%
610   SELect ON wh
620    =0:RESTORE 2000:flin%=2000:llin%=2140
630    =1:RESTORE 3000:flin%=3000:llin%=3150
640    =2:RESTORE 4000:flin%=4000:llin%=4150
650    =3:RESTORE 5000:flin%=5000:llin%=5160
660   END SELect
670   offset=6+NL%-(NL% && 1) :REMark Find the PROC code
680   POKE_W b,(NL%+8) DIV 8 : POKE_W b+2,offset+8 : POKE b+4,NL%
690   FOR i=5 TO NL%+4 : POKE i+b,Upp(name$(i-4))
700   b=b+offset : POKE_L b,0 : POKE_W b+4,0 : b=b+6 : base=b
710   FOR lnum=flin% TO llin% STEP 10 : DATASTORE lnum
720   POKE_L base+122,file_data : IF reent%=0 : POKE_L base+128,file_length
730   LBYTES source$,b :REMark Load task to end of code
740   size=file_length+b-buffer
750   REPeat try
760     fault=DEVICE_STATUS(2,destin$)
770     SELect ON fault
780       ON fault=-8
790         PRINT destin$!'already exists - Delete (Y/N) ? ';
800         k$=INKEY$(#1,-1) : PRINT k$
810         IF k$=='y' THEN DELETE destin$ : NEXT try
820       ON fault=0 TO size-1
830         PRINT 'Insufficient space on drive for '!destin$
840       ON fault=size TO 1E99
850         SBYTES destin$,buffer,file_length+b-buffer
860         PRINT \name$!"keyword code has been created in"!destin$
870       ON fault=REMAINDER
880         PRINT 'Qdos error'!fault!'writing'!destin$
890     END SELect
900     EXIT try
910   END REPeat try
920   DEALLOCATE buffer
930 END REPeat maker
940 REMark IF popup>0
950 REMark   MOVE_MEMORY scrsize,popup TO scrposn
960 REMark   DEALLOCATE popup
970 REMark END IF
980 STOP
990 :
1000 DEFine PROCedure DATASTORE(line%)
1010 LOCal i, x, words%, key%, checksum%
1020 key%=3 : READ checksum%, words%
1030 IF b+words%*2>top:PRINT "Buffer too small @ line "&line%:Stip
1040 FOR i=0 TO words% * 2 -2 STEP 2
1050   READ x : POKE_W i+b,x
1060   IF x>32767 THEN x=x-65536
1070   key%=key% ^^ x ^^ i
1080 END FOR i
1090 IF key%<>checksum%
1100   PRINT "Error in DATA line" ! line% : Stip
1110 END IF
1120 b=b + words% * 2
1130 END DEFine DATASTORE
1140 :
1150 REMark BASIC Initialisation code
1160 DATA 14403,5,17402,8,13432,272,20178
1170 :
1180 DEFine PROCedure Tell(x_pos%,o)
1190  LOCal a$(4)
1200  IF o:a$="Yes":ELSE a$="No "
1210  AT#4, 3,x_pos%:PRINT#4, a$
1220 END DEFine
1230 :
1240 DEFine FuNction Upp(a$)
1250  REMark to return upper case letters
1260  LOCal o,x
1270  o=CODE(a$)
1280  SELect ON o
1290   =CODE('a') TO CODE ('z'):x=o&&-33
1300   =REMAINDER :x=o
1310  END SELect
1320  RETurn x
1330 END DEFine
1340 :
1350 DATA "$`#*","TASConf   !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
1360 DATA -4444:REMark Default channel #1
1370 DATA -4444:REMark Reentrant Code
1380 :
1390 DEFine PROCedure Stip
1400  LOCal k$(2)
1410  OPEN#10,CON:k$=INKEY$(#10,400):CLOSE#10:STOP
1420 END DEFine
1430 :
1980 REMark Resident procedure code
1990 REMark Type 00
2000 DATA -15748,9,28922,20085,11310,88,32256,31232,48075,26472,2101
2010 DATA 4706,9,4,59641,26384,2245,31,18997,59640,26118,20877
2020 DATA -20104,9,48075,26448,18997,59641,27418,10315,18413,65528,13432
2030 DATA 10648,9,278,20114,26310,14897,59392,47563,26420,10827,9804
2040 DATA 5078,9,13432,280,20114,26290,15875,10313,12337,59394,49404
2050 DATA 20231,9,40,53422,48,45230,52,27802,8246,2048,27540
2060 DATA -23817,9,9088,59392,22665,21315,26334,8780,9788,0,0
2070 DATA 23085,9,9276,0,0,12807,53825,53825,53829,18625,54913
2080 DATA -19726,9,2179,0,29439,37833,28673,20033,19072,26212,18928
2090 DATA -2579,9,10248,18420,14584,19074,26388,59530,8776,17914,84
2100 DATA 1069,9,8922,8922,8922,8922,20938,65526,12295,53312,19013
2110 DATA -26637,9,26116,16995,24582,22085,57933,53317,38592,38592,47052
2120 DATA -11072,9,25880,10315,8814,88,24582,14065,59392,21641,20936
2130 DATA 32032,9,65528,14599,8524,65524,11590,88,29712,30463,19077
2140 DATA 27703,5,27138,30208,28682,20033,20085
2145 :
2150 REMark Type 01
3000 DATA -15748,9,28922,20085,11310,88,32256,31232,48075,26472,2101
3010 DATA 4706,9,4,59641,26384,2245,31,18997,59640,26118,20877
3020 DATA -20104,9,48075,26448,18997,59641,27418,10315,18413,65528,13432
3030 DATA 10648,9,278,20114,26310,14897,59392,47563,26420,10827,9804
3040 DATA 5078,9,13432,280,20114,26290,15875,10313,12337,59394,49404
3050 DATA 20231,9,40,53422,48,45230,52,27802,8246,2048,27540
3060 DATA -23817,9,9088,59392,22665,21315,26334,8780,9788,0,0
3070 DATA -12178,9,9276,0,0,12807,26114,29185,53825,53825,53829
3080 DATA 806,9,18625,54913,2179,0,29439,37833,28673,20033,19072
3090 DATA -24639,9,26226,18928,10248,18420,14584,19074,26388,59530,8776
3100 DATA -9296,9,17914,98,8922,8922,8922,8922,20938,65526,12295
3110 DATA 11514,9,53312,19013,26116,16995,24582,22085,57933,53317,38592
3120 DATA -3917,9,38592,47052,25894,10315,8814,88,24582,14065,59392
3130 DATA -23154,9,21641,20936,65528,19015,26122,32257,9326,48,10550
3140 DATA 10992,9,43048,14599,8524,65524,11590,88,29712,30463,19077
3150 DATA 27703,5,27138,30208,28682,20033,20085
3160 :
3170 REMark Type 10
4000 DATA -15748,9,28922,20085,11310,88,32256,31232,48075,26472,2101
4010 DATA 4706,9,4,59641,26384,2245,31,18997,59640,26118,20877
4020 DATA -20104,9,48075,26448,18997,59641,27418,10315,18413,65528,13432
4030 DATA 10648,9,278,20114,26310,14897,59392,47563,26420,10827,9804
4040 DATA 5078,9,13432,280,20114,26290,15875,10313,12337,59394,49404
4050 DATA 20231,9,40,53422,48,45230,52,27802,8246,2048,27540
4060 DATA -23817,9,9088,59392,22665,21315,26334,8780,9788,0,0
4070 DATA 23085,9,9276,0,0,12807,53825,53825,53829,18625,54913
4080 DATA 6503,9,2179,0,17402,136,3177,19195,6,26126,29215
4090 DATA -17786,9,29706,54337,54377,8,17985,50241,29439,28673,20033
4100 DATA -2273,9,19072,26212,18928,10248,18420,14584,19074,26388,59530
4110 DATA -13879,9,8776,17914,84,8922,8922,8922,8922,20938,65526
4120 DATA -30147,9,12295,53312,19013,26116,16995,24582,22085,57933,53317
4130 DATA -29107,9,38592,38592,47052,25880,10315,8814,88,24582,14065
4140 DATA -10229,9,59392,21641,20936,65528,14599,8524,65524,11590,88
4150 DATA 9301,8,29712,30463,19077,27138,30208,28682,20033,20085
4155 :
4160 REMark Type 11
5000 DATA -15748,9,28922,20085,11310,88,32256,31232,48075,26472,2101
5010 DATA 4706,9,4,59641,26384,2245,31,18997,59640,26118,20877
5020 DATA -20104,9,48075,26448,18997,59641,27418,10315,18413,65528,13432
5030 DATA 10648,9,278,20114,26310,14897,59392,47563,26420,10827,9804
5040 DATA 5078,9,13432,280,20114,26290,15875,10313,12337,59394,49404
5050 DATA 20231,9,40,53422,48,45230,52,27802,8246,2048,27540
5060 DATA -23817,9,9088,59392,22665,21315,26334,8780,9788,0,0
5070 DATA -12178,9,9276,0,0,12807,26114,29185,53825,53825,53829
5080 DATA -27864,9,18625,54913,2179,0,17402,150,3177,19195,6
5090 DATA -28457,9,26126,29215,29706,54337,54377,8,17985,50241,29439
5100 DATA 18135,9,28673,20033,19072,26226,18928,10248,18420,14584,19074
5110 DATA -6051,9,26388,59530,8776,17914,98,8922,8922,8922,8922
5120 DATA 5641,9,20938,65526,12295,53312,19013,26116,16995,24582,22085
5130 DATA -5492,9,57933,53317,38592,38592,47052,25894,10315,8814,88
5140 DATA 5649,9,24582,14065,59392,21641,20936,65528,19015,26122,32257
5150 DATA 28658,9,9326,48,10550,43048,14599,8524,65524,11590,88
5160 DATA 9301,8,29712,30463,19077,27138,30208,28682,20033,20085
